/*
ADC Routinen fr die Wandlung
*/
#include <stdlib.h>
#include <avr/io.h>


void adc_init (void) //Initialsierung
{
//Sicherstellen das Analog-Digital-Converter eingeschaltet ist
PRR=(0<<PRADC);
DIDR0=(1<<ADC2D);
//------------------------------------------------------------------------------------------
//ADC Multiplexer Selecter Register
//------------------------------------------------------------------------------------------
//		REFS1		REFS0		ADLAR		MUX4	MUX3	MUX2	MUX1	MUX0
//		  Referenzspannungs
//								  1		=>	Ausgabe des Ergebniss linksbndig (1) bei (0) rechtsbndig)
//											 {---------------Kanalbestimmung----}
//------------------------------------------------------------------------------------------

//Refferenzspannung							Kanalauswahl
//		 REFS1	REFS0	Wert						MUX3	MUX2	MUX1	MUX0	ADC_Kanal
//			0		0	Externe AREF				0		0		0		0		ADC0
//			0		1	AVCC als AREF				0		0		0		1		ADC1
//			1		0	Reserviert					0		0		1		0		ADC2
//			1		1	Interne 2,56V				0		0		1		1		ADC3
//													0		1		0		0		ADC4
//													0		1		0		1		ADC5
//													0		1		1		0		ADC6
//													0		1		1		1		ADC7
//-------------------------------------------------------------------------------------------



ADMUX =(1<<ADLAR);  //Externe Refferenzspannung;Ergebniss links und Kanal ADC0
//ADMUX =0x22;


//-----------------------------------------------------------------------------------------
//ADC Controll und STATUS REGISTER
//-----------------------------------------------------------------------------------------
//  ADEN		ADSC		ADATE		ADIF		ADIE	ADPS2		ADPS1		ADPS0
//	  1		=>	Wandlereinschalten und I/O PINS belegen
//				  1		=>	Wandler starten 
//							  0		=>Betriebsart 1=Dauerhafte Wandlung 0= Wandlung nur bei Aufruf	
//										  "1/0" 	=>STATUS Wird vom Wandler gesetzt wenn neue Ergebnisse im Speicher
//													 "1/0"  => Status wenn I-Flag (SFR) und ADIE gesetzt startet ADC Routine
//														" Teilungsfaktoren fr Eingangsfrequenz ADC"
//-----------------------------------------------------------------------------------------


// ADPS 2	ADPS1	ADPS0	Teilungsfaktor
//	0		  0		  0			  2
//	0		  0		  1			  2
//	0		  1		  0			  4
//	0		  1		  1			  8
//	1 		  0		  0			 16
//	1		  0		  1			 32		
//	1		  1		  0			 64
//	1		  1		  1			128

//Der ADC Takt soll zwischen 50 und 200kHz eingestellt werden
//TF_min=FOSC/50000
//TF_max=FOSC/20000 


	ADCSRA =(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);  



}
//Fr die berprfung der Funktion kann die Ausgabe ber die USART SChnittstelle eingestellt werden

uint16_t adc_read (void) //Auslesen der ADC
{
	char buffer[20];
	
	uint16_t result;
	ADCSRA |= (1>>ADSC);
	while (ADCSRA & (1<<ADSC)) { // auf Abschluss der Konvertierung warten 
    
	usart_puts("--------------------------11111----------------------------\r\n");
	usart_puts("ADCSRA___");
	utoa(ADCSRA, buffer, 10);
	usart_puts(buffer);                 
	usart_puts("--------------------------11111----------------------------\r\n");
  
  }
    //Testumgebung fr den Analog-Digitalwandler
	
	usart_puts("---------------------------------------------------");
	usart_puts("\r\n");
	usart_puts("DIDR0___");
	utoa(DIDR0, buffer, 10);
	usart_puts(buffer);
	
	usart_puts("\r\n");
	usart_puts("ADMUX   ");
	utoa(ADMUX, buffer, 10);
	usart_puts(buffer);
	
	usart_puts("\r\n");
	usart_puts("ADCSRA___");
	utoa(ADCSRA, buffer, 10);
	usart_puts(buffer);
	
	usart_puts("\r\n");
	usart_puts("---------------------------------------------------");
    
	
	usart_puts("\r\n");
    utoa(ADCH, buffer, 10);
    usart_puts("adch= ");
    usart_puts(buffer);
    
	
	usart_puts("\r\n");
	utoa(ADCL, buffer, 10);
	usart_puts("adcl= ");
    usart_puts(buffer);
	
	usart_puts("\r\n");
	utoa(ADCW, buffer, 10);
	usart_puts("adcw= ");
    usart_puts(buffer);
	usart_puts("\r\n");
	usart_puts("--------------------------------------------------");
	usart_puts("\r\n");

	//-----------------------------------------
	result=ADCW; 
	
	return result;
}



