/* In diesem Baustein sind all Funktionen fr die Initialisierung der USART Schnittstelle
 des Mega 88 definiert




*/

#include <stdlib.h>
#include <avr/io.h>
#include <stdint.h>		//Definition der Standard-Variablen und typen
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <inttypes.h>


//------------------------Initialisierungroutine-------------------------------

void usart_init (unsigned int ubrr)
{
//Einstellung der Baudrate
UBRR0H= (unsigned char) (ubrr>>8);
UBRR0L= (unsigned char) ubrr;

//Receiver und Transmitter einschalten
UCSR0B= (1<<RXEN0)|(1<<TXEN0);



//Datenlnge festlegen

//--------------------------------USR0C Register---------------------------------------------
// UMSEL01    UMSEL00 	UPM01	UPM00 	USBS0 	UCSZ01 	UCSZ00 	UCPOL0
//  0			0 	=> Asynchronermodus
//						  0		  0 => Paritybit
//								  		  1 => Anzahlstopbits = 2 (bei 0 =1)
//										  		   1		   1 => Anzahl der Datenbits =8
//														   		   0 => Flankeauswertung (Rising Transmit) (Falling Received)
//--------------------------------------------------------------------------------------------
UCSR0C= (1<<USBS0)|(3<<UCSZ00); //8 Datenbits und 2 Stopbits

}

//----------------------Senderoutine---------------------------------------------

void usart_transmit (unsigned char data)
{
//Auf leere Transmitter-Puffer warten
while (!(UCSR0A & (1<<UDRE0) ) )
;
UDR0=data; //Daten in den Pufferschreiben
}

//----------------------String Sendefunktion--------------------------------------
void usart_puts(char *s)
{	//So lange wie *s ungleich vom String Endezeichen ist senden
	while (*s)
	{
	usart_transmit(*s);
	s++;
	}
}

